# coding: utf-8

from __future__ import annotations

from abc import ABC

from datetime import date, datetime  # noqa: F401
from enum import Enum, IntEnum

import re  # noqa: F401
from typing import Any, Dict, List, Optional, Type, Union, Callable  # noqa: F401
from pathlib import Path
from typing import TypeVar
Model = TypeVar('Model', bound='BaseModel')
StrBytes = Union[str, bytes]

from pydantic import AnyUrl, BaseModel, EmailStr, Field, validator, root_validator, Extra,PrivateAttr  # noqa: F401
from pydantic import ValidationError
from pydantic.error_wrappers import ErrorWrapper
from pydantic.utils import ROOT_KEY
from json import encoder

from dnv_bladed_models.event import Event



from .schema_helper import SchemaHelper 
from .models_impl import *
from .common_base_model import CommonBaseModel

class TimedEvent(Event, ABC):
    r"""
    An event that occurs at a specified time in the simulation.
    
    Not supported yet.
    
    Attributes:
    ----------
    TimeOccurs : float, Not supported yet
        The time at which the event occurs.  This is measured from the start of the output recording, and ignores any lead-in time.

    Notes:
    -----This model is not supported yet by the Bladed calculation engine.
    """
    _relative_schema_path: str = PrivateAttr('TimeDomainSimulation/Event/common/TimedEvent.json')
    
    TimeOccurs: Optional[float] = Field(alias="TimeOccurs", default=None) # Not supported yet





TimedEvent.update_forward_refs()
