# coding: utf-8

from __future__ import annotations

from abc import ABC

from datetime import date, datetime  # noqa: F401
from enum import Enum, IntEnum

import re  # noqa: F401
from typing import Any, Dict, List, Optional, Type, Union, Callable  # noqa: F401
from pathlib import Path
from typing import TypeVar
Model = TypeVar('Model', bound='BaseModel')
StrBytes = Union[str, bytes]

from pydantic import AnyUrl, BaseModel, EmailStr, Field, validator, root_validator, Extra,PrivateAttr  # noqa: F401
from pydantic import ValidationError
from pydantic.error_wrappers import ErrorWrapper
from pydantic.utils import ROOT_KEY
from json import encoder

from dnv_bladed_models.bladed_model import BladedModel



from .schema_helper import SchemaHelper 
from .models_impl import *
from .common_base_model import CommonBaseModel

class TowerCanSectionPropertiesWhereDifferent(BladedModel, ABC):
    r"""
    The definition of a can section where the material properties, the diameter, and the wall thickness will be used to calculate the physical properties.  Any properties which are omitted will be taken from the BaseSection definition.
    
    Attributes:
    ----------
    OutsideDiameter : float
        The external diameter of the can at this location.  If omitted, the value from the BaseSection will be used.

    Notes:
    -----
    """
    _relative_schema_path: str = PrivateAttr('Components/Tower/TowerCan/common/TowerCanSectionPropertiesWhereDifferent.json')
    
    OutsideDiameter: Optional[float] = Field(alias="OutsideDiameter", default=None)





TowerCanSectionPropertiesWhereDifferent.update_forward_refs()
